## org.eclipse.xsd
Interface XSDConcreteComponent

All Superinterfaces:
  EObject, Notifier

All Known Subinterfaces:
  XSDAnnotation, XSDAttributeDeclaration, XSDAttributeGroupContent, XSDAttributeGroupDefinition, XSDAttributeUse, XSDBoundedFacet, XSDCardinalityFacet, XSDComplexTypeContent, XSDComplexTypeDefinition, XSDComponent, XSDConstrainingFacet, XSDDiagnostic, XSDElementDeclaration, XSDEnumerationFacet, XSDFacet, XSDFeature, XSDFixedFacet, XSDFractionDigitsFacet, XSDFundamentalFacet, XSDIdentityConstraintDefinition, XSDImport, XSDInclude, XSDLengthFacet, XSDMaxExclusiveFacet, XSDMaxFacet, XSDMaxInclusiveFacet, XSDMaxLengthFacet, XSDMinExclusiveFacet, XSDMinFacet, XSDMinInclusiveFacet, XSDMinLengthFacet, XSDModelGroup, XSDModelGroupDefinition, XSDNamedComponent, XSDNotationDeclaration, XSDNumericFacet, XSDOrderedFacet, XSDParticle, XSDParticleContent, XSDPatternFacet, XSDRedefinableComponent, XSDRedefine, XSDRedefineContent, XSDRepeatableFacet, XSDSchema, XSDSchemaCompositor, XSDSchemaContent, XSDSchemaDirective, XSDScope, XSDSimpleTypeDefinition, XSDTerm, XSDTotalDigitsFacet, XSDTypeDefinition, XSDWhiteSpaceFacet, XSDWildcard, XSDXPathDefinition

All Known Implementing Classes:
  XSDAnnotationImpl, XSDAttributeDeclarationImpl, XSDAttributeGroupContentImpl, XSDAttributeGroupDefinitionImpl, XSDAttributeUseImpl, XSDBoundedFacetImpl, XSDCardinalityFacetImpl, XSDComplexTypeContentImpl, XSDComplexTypeDefinitionImpl, XSDComponentImpl, XSDConcreteComponentImpl, XSDConstrainingFacetImpl, XSDDiagnosticImpl, XSDElementDeclarationImpl, XSDEnumerationFacetImpl, XSDFacetImpl, XSDFeatureImpl, XSDFixedFacetImpl, XSDFractionDigitsFacetImpl, XSDFundamentalFacetImpl, XSDIdentityConstraintDefinitionImpl, XSDImportImpl, XSDIncludeImpl, XSDLengthFacetImpl, XSDMaxExclusiveFacetImpl, XSDMaxFacetImpl, XSDMaxInclusiveFacetImpl, XSDMaxLengthFacetImpl, XSDMinExclusiveFacetImpl, XSDMinFacetImpl, XSDMinInclusiveFacetImpl, XSDMinLengthFacetImpl, XSDModelGroupDefinitionImpl, XSDModelGroupImpl, XSDNamedComponentImpl, XSDNotationDeclarationImpl, XSDNumericFacetImpl, XSDOrderedFacetImpl, XSDParticleContentImpl, XSDParticleImpl, XSDPatternFacetImpl, XSDRedefinableComponentImpl, XSDRedefineContentImpl, XSDRedefineImpl, XSDRepeatableFacetImpl, XSDSchemaCompositorImpl, XSDSchemaContentImpl, XSDSchemaDirectiveImpl, XSDSchemaImpl, XSDScopeImpl, XSDSimpleTypeDefinitionImpl, XSDTermImpl, XSDTotalDigitsFacetImpl, XSDTypeDefinitionImpl, XSDWhiteSpaceFacetImpl, XSDWildcardImpl, XSDXPathDefinitionImpl

    public interface XSDConcreteComponent

extends EObject

A representation of the model object 'Concrete Component'. It is the root of all concrete components.

The following features are supported:

- `Element`
- `Container`
- `Root Container`
- `Schema`
- `Diagnostics`

See Also:
  `XSDPackage.getXSDConcreteComponent()`

Method Summary
`void` `clearDiagnostics()` Clears any `diagnostics` associated with the component and all those it contains.
`XSDConcreteComponent` `cloneConcreteComponent(boolean deep, boolean shareDOM)` Creates a clone of the component.
`boolean` `contains(XSDConcreteComponent xsdConcreteComponent)` Returns whether the given component is contained by this component.
`void` `elementAttributesChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed attributes; the element should typically be the same as the one returned `getElement()`.
`void` `elementChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed; the element should typically be the same as the one returned `getElement()`.
`void` `elementContentsChanged(org.w3c.dom.Element changedElement)` Called to indicate that the given element has changed contents; the element should typically be the same as the one returned `getElement()`.
`java.util.Collection<XSDConcreteComponent>` `getComponentsWithApplicationInformation(java.lang.String sourceURI)` Returns the collection of components that have an `annotation` containing an `appinfo` with given source URI.
`java.util.Collection<XSDConcreteComponent>` `getComponentsWithUserInformation(java.lang.String sourceURI)` Returns the collection of components that have an `annotation` containing a `documentation` with given source URI.
`XSDConcreteComponent` `getContainer()` Returns the value of the 'Container' reference
`EList<XSDDiagnostic>` `getDiagnostics()` Returns the value of the 'Diagnostics' containment reference list.
`org.w3c.dom.Element` `getElement()` Returns the value of the 'Element' attribute
`XSDConcreteComponent` `getRootContainer()` Returns the value of the 'Root Container' reference
`XSDSchema` `getSchema()` Returns the value of the 'Schema' reference
`XSDAttributeDeclaration` `resolveAttributeDeclaration(java.lang.String localName)` Returns the resolved attribute declaration of the given `name` within the `schema`.
`XSDAttributeDeclaration` `resolveAttributeDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute declaration of the given `namespace` and `name`.
`XSDAttributeDeclaration` `resolveAttributeDeclarationURI(java.lang.String uri)` Returns the resolved attribute declaration of the given `URI`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinition(java.lang.String localName)` Returns the resolved attribute group definition of the given `name` within the `schema`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved attribute group definition the given `namespace` and `name`.
`XSDAttributeGroupDefinition` `resolveAttributeGroupDefinitionURI(java.lang.String uri)` Returns the resolved attribute group definition of the given `URI`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinition(java.lang.String localName)` Returns the resolved complex type definition of the given `name` within the `schema`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved complex type definition of the given `namespace` and `name`.
`XSDComplexTypeDefinition` `resolveComplexTypeDefinitionURI(java.lang.String uri)` Returns the resolved complex type definition of the given `URI`.
`XSDElementDeclaration` `resolveElementDeclaration(java.lang.String localName)` Returns the resolved element declaration of the given `name` within the `schema`.
`XSDElementDeclaration` `resolveElementDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved element declaration of the given `namespace` and `name`.
`XSDElementDeclaration` `resolveElementDeclarationURI(java.lang.String uri)` Returns the resolved element declaration of the given `URI`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinition(java.lang.String localName)` Returns the resolved identity constraint definition of the given `name` within the `schema`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved identity constraint definition of the given `namespace` and `name`.
`XSDIdentityConstraintDefinition` `resolveIdentityConstraintDefinitionURI(java.lang.String uri)` Returns the resolved identity constraint definition of the given `URI`.
`XSDModelGroupDefinition` `resolveModelGroupDefinition(java.lang.String localName)` Returns the resolved model group definition of the given `name` within the `schema`.
`XSDModelGroupDefinition` `resolveModelGroupDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved model group definition of the given `namespace` and `name`.
`XSDModelGroupDefinition` `resolveModelGroupDefinitionURI(java.lang.String uri)` Returns the resolved model group definition of the given `URI`.
`XSDNotationDeclaration` `resolveNotationDeclaration(java.lang.String localName)` Returns the resolved notation declaration the given `name` within the `schema`.
`XSDNotationDeclaration` `resolveNotationDeclaration(java.lang.String namespace, java.lang.String localName)` Returns the resolved notation declaration of the given `namespace` and `name`.
`XSDNotationDeclaration` `resolveNotationDeclarationURI(java.lang.String uri)` Returns the resolved notation declaration of the given `URI`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinition(java.lang.String localName)` Returns the resolved simple type definition of the given `name` within the `schema`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved simple type definition of the given `namespace` and `name`.
`XSDSimpleTypeDefinition` `resolveSimpleTypeDefinitionURI(java.lang.String uri)` Returns the resolved simple type definition of the given `URI`.
`XSDTypeDefinition` `resolveTypeDefinition(java.lang.String localName)` Returns the resolved type definition of the given `name` within the `schema`.
`XSDTypeDefinition` `resolveTypeDefinition(java.lang.String namespace, java.lang.String localName)` Returns the resolved type definition of the given `namespace` and `name`.
`XSDTypeDefinition` `resolveTypeDefinitionURI(java.lang.String uri)` Returns the resolved type definition of the given `URI`.
`void` `setElement(org.w3c.dom.Element value)` Sets the value of the '`Element`' attribute
`void` `updateElement()` Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.
`void` `updateElement(boolean deep)` Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.
`void` `validate()` Validates whether this component conforms to the constraints defined in the XML Schema standard.

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### getElement

    org.w3c.dom.Element getElement()

  Returns the value of the 'Element' attribute.

  This is the underlying DOM element associated with this component, i.e., the `serialization` of this component.

  Returns:
    the value of the 'Element' attribute.
  See Also:
    `setElement(Element)`, `XSDPackage.getXSDConcreteComponent_Element()`

### setElement

    void setElement(org.w3c.dom.Element value)

  Sets the value of the '`Element`' attribute.

  Parameters:
    `value` - the new value of the 'Element' attribute.
  See Also:
    `getElement()`

### updateElement

    void updateElement()

  Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization.

  See Also:
    `updateElement(boolean)`, `getElement()`

### updateElement

    void updateElement(boolean deep)

  Ensures that the underlying DOM `element` both exists and is up-to-date with respect to the model, i.e., it serializes the component and maintains an association with that serialization. For `deep == true`, or when ``getElement()` == null`, this does the same thing as `updateElement()`; otherwise, it updates just the DOM element associated with this component to reflect the current state.

  See Also:
    `updateElement()`, `getElement()`

### getContainer

    XSDConcreteComponent getContainer()

  Returns the value of the 'Container' reference.

  This represents the concrete container of this component, i.e., the inverse of the black diamond relations in the UML model.

  Returns:
    the value of the 'Container' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Container()`

### getRootContainer

    XSDConcreteComponent getRootContainer()

  Returns the value of the 'Root Container' reference.

  This walks the `containers` until it hits one that has no container.

  Returns:
    the value of the 'Root Container' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_RootContainer()`

### getSchema

    XSDSchema getSchema()

  Returns the value of the 'Schema' reference.

  This walks the `containers` until it reaches a schema.

  Returns:
    the value of the 'Schema' reference.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Schema()`

### getDiagnostics

    EList<XSDDiagnostic> getDiagnostics()

  Returns the value of the 'Diagnostics' containment reference list. The list contents are of type `XSDDiagnostic`.

  These diagnostics are produced by `validation`.

  Returns:
    the value of the 'Diagnostics' containment reference list.
  See Also:
    `XSDPackage.getXSDConcreteComponent_Diagnostics()`

### elementChanged

    void elementChanged(org.w3c.dom.Element changedElement)

  Called to indicate that the given element has changed; the element should typically be the same as the one returned `getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

### elementAttributesChanged

    void elementAttributesChanged(org.w3c.dom.Element changedElement)

  Called to indicate that the given element has changed attributes; the element should typically be the same as the one returned `getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

### elementContentsChanged

    void elementContentsChanged(org.w3c.dom.Element changedElement)

  Called to indicate that the given element has changed contents; the element should typically be the same as the one returned `getElement()`. It is expected that clients will not call this themselves since the DOM event listeners attached to the underlying DOM will invoke these automatically.

### resolveTypeDefinitionURI

    XSDTypeDefinition resolveTypeDefinitionURI(java.lang.String uri)

  Returns the resolved type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `resolveTypeDefinition(java.lang.String, java.lang.String)`, `resolveTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveTypeDefinition

    XSDTypeDefinition resolveTypeDefinition(java.lang.String namespace,
                                            java.lang.String localName)

  Returns the resolved type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `resolveTypeDefinitionURI(java.lang.String)`, `resolveTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveTypeDefinition

    XSDTypeDefinition resolveTypeDefinition(java.lang.String localName)

  Returns the resolved type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved type definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveTypeDefinitionURI(java.lang.String)`, `resolveTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveSimpleTypeDefinitionURI

    XSDSimpleTypeDefinition resolveSimpleTypeDefinitionURI(java.lang.String uri)

  Returns the resolved simple type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `resolveSimpleTypeDefinition(java.lang.String, java.lang.String)`, `resolveSimpleTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveSimpleTypeDefinition

    XSDSimpleTypeDefinition resolveSimpleTypeDefinition(java.lang.String namespace,
                                                        java.lang.String localName)

  Returns the resolved simple type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `resolveSimpleTypeDefinitionURI(java.lang.String)`, `resolveSimpleTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveSimpleTypeDefinition

    XSDSimpleTypeDefinition resolveSimpleTypeDefinition(java.lang.String localName)

  Returns the resolved simple type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved simple type definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveSimpleTypeDefinitionURI(java.lang.String)`, `resolveSimpleTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveComplexTypeDefinitionURI

    XSDComplexTypeDefinition resolveComplexTypeDefinitionURI(java.lang.String uri)

  Returns the resolved complex type definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `resolveComplexTypeDefinition(java.lang.String, java.lang.String)`, `resolveComplexTypeDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveComplexTypeDefinition

    XSDComplexTypeDefinition resolveComplexTypeDefinition(java.lang.String namespace,
                                                          java.lang.String localName)

  Returns the resolved complex type definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `resolveComplexTypeDefinitionURI(java.lang.String)`, `resolveComplexTypeDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveComplexTypeDefinition

    XSDComplexTypeDefinition resolveComplexTypeDefinition(java.lang.String localName)

  Returns the resolved complex type definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved complex type definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveComplexTypeDefinitionURI(java.lang.String)`, `resolveComplexTypeDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveAttributeDeclarationURI

    XSDAttributeDeclaration resolveAttributeDeclarationURI(java.lang.String uri)

  Returns the resolved attribute declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `resolveAttributeDeclaration(java.lang.String, java.lang.String)`, `resolveAttributeDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveAttributeDeclaration

    XSDAttributeDeclaration resolveAttributeDeclaration(java.lang.String namespace,
                                                        java.lang.String localName)

  Returns the resolved attribute declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `resolveAttributeDeclarationURI(java.lang.String)`, `resolveAttributeDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveAttributeDeclaration

    XSDAttributeDeclaration resolveAttributeDeclaration(java.lang.String localName)

  Returns the resolved attribute declaration of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved attribute declaration.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveAttributeDeclarationURI(java.lang.String)`, `resolveAttributeDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveElementDeclarationURI

    XSDElementDeclaration resolveElementDeclarationURI(java.lang.String uri)

  Returns the resolved element declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `resolveElementDeclaration(java.lang.String, java.lang.String)`, `resolveElementDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveElementDeclaration

    XSDElementDeclaration resolveElementDeclaration(java.lang.String namespace,
                                                    java.lang.String localName)

  Returns the resolved element declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `resolveElementDeclarationURI(java.lang.String)`, `resolveElementDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveElementDeclaration

    XSDElementDeclaration resolveElementDeclaration(java.lang.String localName)

  Returns the resolved element declaration of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved element declaration.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveElementDeclarationURI(java.lang.String)`, `resolveElementDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveAttributeGroupDefinitionURI

    XSDAttributeGroupDefinition resolveAttributeGroupDefinitionURI(java.lang.String uri)

  Returns the resolved attribute group definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved attribute group definition.
  See Also:
    `resolveAttributeGroupDefinition(java.lang.String, java.lang.String)`, `resolveAttributeGroupDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveAttributeGroupDefinition

    XSDAttributeGroupDefinition resolveAttributeGroupDefinition(java.lang.String namespace,
                                                                java.lang.String localName)

  Returns the resolved attribute group definition the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved attribute group definition
  See Also:
    `resolveAttributeGroupDefinitionURI(java.lang.String)`, `resolveAttributeGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveAttributeGroupDefinition

    XSDAttributeGroupDefinition resolveAttributeGroupDefinition(java.lang.String localName)

  Returns the resolved attribute group definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved attribute group definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveAttributeGroupDefinitionURI(java.lang.String)`, `resolveAttributeGroupDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveModelGroupDefinitionURI

    XSDModelGroupDefinition resolveModelGroupDefinitionURI(java.lang.String uri)

  Returns the resolved model group definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `resolveModelGroupDefinition(java.lang.String, java.lang.String)`, `resolveModelGroupDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveModelGroupDefinition

    XSDModelGroupDefinition resolveModelGroupDefinition(java.lang.String namespace,
                                                        java.lang.String localName)

  Returns the resolved model group definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `resolveModelGroupDefinitionURI(java.lang.String)`, `resolveModelGroupDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveModelGroupDefinition

    XSDModelGroupDefinition resolveModelGroupDefinition(java.lang.String localName)

  Returns the resolved model group definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved model group definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveModelGroupDefinitionURI(java.lang.String)`, `resolveModelGroupDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveIdentityConstraintDefinitionURI

    XSDIdentityConstraintDefinition resolveIdentityConstraintDefinitionURI(java.lang.String uri)

  Returns the resolved identity constraint definition of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `resolveIdentityConstraintDefinition(java.lang.String, java.lang.String)`, `resolveIdentityConstraintDefinition(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveIdentityConstraintDefinition

    XSDIdentityConstraintDefinition resolveIdentityConstraintDefinition(java.lang.String namespace,
                                                                        java.lang.String localName)

  Returns the resolved identity constraint definition of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `resolveIdentityConstraintDefinitionURI(java.lang.String)`, `resolveIdentityConstraintDefinition(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveIdentityConstraintDefinition

    XSDIdentityConstraintDefinition resolveIdentityConstraintDefinition(java.lang.String localName)

  Returns the resolved identity constraint definition of the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved identity constraint definition.
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveIdentityConstraintDefinitionURI(java.lang.String)`, `resolveIdentityConstraintDefinition(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### resolveNotationDeclarationURI

    XSDNotationDeclaration resolveNotationDeclarationURI(java.lang.String uri)

  Returns the resolved notation declaration of the given `URI`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `uri` - the URI to resolve.
  Returns:
    the resolved notation declaration.
  See Also:
    `resolveNotationDeclaration(java.lang.String, java.lang.String)`, `resolveNotationDeclaration(java.lang.String)`, `XSDNamedComponent.getURI()`

### resolveNotationDeclaration

    XSDNotationDeclaration resolveNotationDeclaration(java.lang.String namespace,
                                                      java.lang.String localName)

  Returns the resolved notation declaration of the given `namespace` and `name`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `namespace` - the namespace to resolve.
    `localName` - the name to resolve.
  Returns:
    the resolved notation declaration.
  See Also:
    `resolveNotationDeclarationURI(java.lang.String)`, `resolveNotationDeclaration(java.lang.String)`, `XSDNamedComponent.getTargetNamespace()`, `XSDNamedComponent.getName()`

### resolveNotationDeclaration

    XSDNotationDeclaration resolveNotationDeclaration(java.lang.String localName)

  Returns the resolved notation declaration the given `name` within the `schema`. An unresolved instance is synthesized to hold the namespace and name if an existing instance cannot be found.

  Parameters:
    `localName` - the name to resolve.
  Returns:
    the resolved notation declaration
  See Also:
    `getSchema()`, `XSDSchema.getTargetNamespace()`, `resolveNotationDeclarationURI(java.lang.String)`, `resolveNotationDeclaration(java.lang.String, java.lang.String)`, `XSDNamedComponent.getName()`

### getComponentsWithApplicationInformation

    java.util.Collection<XSDConcreteComponent> getComponentsWithApplicationInformation(java.lang.String sourceURI)

  Returns the collection of components that have an `annotation` containing an `appinfo` with given source URI.

  Parameters:
    `sourceURI` - the source URI to match.
  Returns:
    the collection of matching components.
  See Also:
    `XSDAnnotation.getApplicationInformationSources()`

### getComponentsWithUserInformation

    java.util.Collection<XSDConcreteComponent> getComponentsWithUserInformation(java.lang.String sourceURI)

  Returns the collection of components that have an `annotation` containing a `documentation` with given source URI.

  Parameters:
    `sourceURI` - the source URI to match.
  Returns:
    the collection of matching components.
  See Also:
    `XSDAnnotation.getApplicationInformationSources()`

### validate

    void validate()

  Validates whether this component conforms to the constraints defined in the XML Schema standard. `Diagnostics` are produced to report any problems. The effect of calling this for a component not directly or indirectly contained by a `schema` is undefined, and is likely to result in null pointer exceptions.

  See Also:
    `getDiagnostics()`, `clearDiagnostics()`

### clearDiagnostics

    void clearDiagnostics()

  Clears any `diagnostics` associated with the component and all those it contains.

  See Also:
    `validate()`, `getDiagnostics()`

### cloneConcreteComponent

    XSDConcreteComponent cloneConcreteComponent(boolean deep,
                                                boolean shareDOM)

  Creates a clone of the component. The clone may be deep and may share the DOM of this component.

  Parameters:
    `deep` - whether the clone should be deep.
    `shareDOM` - whether the clone should share the original DOM
  Returns:
    a clone of the component.

### contains

    boolean contains(XSDConcreteComponent xsdConcreteComponent)

  Returns whether the given component is contained by this component.

  Parameters:
    `xsdConcreteComponent` - a component.
  Returns:
    whether the component is contained by this component.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.